import { defineConfig, loadEnv } from "vite";
import react from "@vitejs/plugin-react";
import { stringToSlug } from "./src/utils";

// https://vitejs.dev/config/
export default () => {
  const env = loadEnv("dev", process.cwd());
    // Sicherstellen, dass die Umgebungsvariable vorhanden ist
  if (!env.VITE_TEAM_NAME) {
    throw new Error("VITE_TEAM_NAME environment variable is not defined");
  }
  // Debugging-Log, um den Wert der Umgebungsvariable zu überprüfen
  console.log(`VITE_TEAM_NAME: ${env.VITE_TEAM_NAME}`);


  const baseSlug = stringToSlug(env.VITE_TEAM_NAME);

  console.log("VITE_TEAM_NAME:", env.VITE_TEAM_NAME); // Debugging-Ausgabe
  console.log("Base Slug:", baseSlug); // Debugging-Ausgabe
  
  return defineConfig({
    base: `/${stringToSlug(env.VITE_TEAM_NAME)}/`,
    plugins: [react()],
    build: {
      outDir: "dist",
    },
    publicDir: 'pubpub',
  });
  
};
